# -*- coding: utf-8 -*-
import os
import time
import sys
import threadpool
from django.core.management.base import BaseCommand
from sale_amazon.models.store_info import Store
from sale_amazon.models.store_info import Amazon_Account
from sale_amazon.interface.inter.amazon_api_implement import get_listing, info_path, send_request2, base_path, proxy_index


reload(sys)
sys.setdefaultencoding('utf-8')

test_account_us = ['Huron','Superior','Taian','zhuhai','JinFengUS','Antoniohell','DHalloween','YTVolkswagen','Los Angeles-WX','ZishiUS','Hezhi','HappyCenter']
test_account_us_2 = ['Michigan']  # zhuhai


acctive_account_US = ['Audius','Huron','XiaMen','Wedbration','B15','Taizhou','qixia','Dragonnest','dalian','Michigan','thinkmax','zhuhai','chengdu','JinFeng','SZDS','BJBuick','jiangsu','hebei',
                      'francisco','B14','HzToyota','Tianjin','Fannie','Itochu','chevron','SZFord','QDJaguar','Boston-WX','HuNan','Utah','NanJing','xiamoUS','Wisconsin','CAROMIO','Jefferson','Lankeling',
                      'YRLED','DHalloween','Louisiana','YTVolkswagen','lansing','Alaska','Cambridge','Kroger','Lukoil','KathyMall','Amazbox','OberLin','MyBarbie','Mountain','APPLUS','Chunli','MoonSharon','Champion','Albany','Barclays',
                      'Calgary','Berklee','F784','LCyuan','AKDSteel','shantou','A4','Reading','WF-1','Lubbock','hellotoysme','DYTesa','VFclar','LosAngeles-WX','ZiningUS','Columbus','Sakala','TomYstore','younghorse','YunmiaoUS',
                      'Minnesota','POSCO','VINCI','inmars','Acekool','Acekid','FTDSakiyr','A3','KitKids','zishi','ChrislyH','Chukoo','Lightroom','LuomingUS','LanleiUS']
store1 = ['Audius','Huron','XiaMen','Wedbration','B15','Taizhou','qixia','Dragonnest','dalian',
         'Michigan','thinkmax','zhuhai','chengdu','JinFeng','SZDS','BJBuick','jiangsu','hebei',]
store2 = ['francisco','B14','HzToyota','Tianjin','Fannie','Itochu','chevron','SZFord','QDJaguar','Boston-WX',
          'HuNan','Utah','NanJing','Utah','NanJing','xiamoUS','Wisconsin','CAROMIO','Jefferson','Lankeling',]
store3 = ['YRLED','DHalloween','Louisiana','YTVolkswagen','lansing','Alaska','Cambridge','Kroger','Lukoil','KathyMall',
         'Amazbox','OberLin','MyBarbie','Mountain','APPLUS','Chunli','MoonSharon','Champion','Albany','Barclays']
store4 = ['Calgary','Berklee','F784','LCyuan','AKDSteel','shantou','A4','Reading','WF-1','Lubbock',
          'hellotoysme','DYTesa','VFclar','LosAngeles-WX','ZiningUS','Columbus','Sakala','TomYstore','younghorse','YunmiaoUS']
store5 = ['Minnesota','POSCO','VINCI','inmars','Acekool','Acekid','FTDSakiyr','A3','KitKids','zishi','ChrislyH','Chukoo','Lightroom','LuomingUS','LanleiUS']

class Command(BaseCommand):
    def handle(self, *args, **options):
        main()

def main():
    os.system('rm ' + info_path + '/*.gz')
    os.system('rm ' + info_path + '/*.csv')
    #stores = Store.objects.filter(channel='Amazon', is_online=True, market_id=2).exclude(name__in=acctive_account_US)
    #accounts = Amazon_Account.objects.filter(idamazon_account__in=[x.account_id for x in stores])
    #if not account:
    #    print account.name
    #print 'stores: ',stores.count()

    accounts = []
    acctive_account_US_lower = [a.lower() for a in test_account_us_2]
    with open(base_path+'/amazon_stores.csv', 'r') as store_info_file:
        lines = store_info_file.readlines()
        for l in lines:
            store_info = l.split(',')
            idamazon_account = store_info[0]
            name = store_info[1]
            ACCESS_KEY = store_info[2]
            SECRET_KEY = store_info[3]
            ACCOUNT_ID = store_info[4]
            MKPLACEID = store_info[5]
            MWSAuthToken = store_info[6][:-1]
            if proxy_index==1:
                if name.lower() in acctive_account_US_lower:
                    print name
                    accounts.append(Amazon_Account(idamazon_account,name,ACCESS_KEY,SECRET_KEY,ACCOUNT_ID,MKPLACEID,MWSAuthToken))
            else:
                if name.lower() not in acctive_account_US_lower:
                    accounts.append(Amazon_Account(idamazon_account,name,ACCESS_KEY,SECRET_KEY,ACCOUNT_ID,MKPLACEID,MWSAuthToken))

    pool = threadpool.ThreadPool(10)
    requests = threadpool.makeRequests(get_listing, accounts)
    [pool.putRequest(req) for req in requests]
    pool.wait()
    pool.dismissWorkers(10, do_join=True)

    count = 0
    while count < 5:
        time.sleep(20)
        ret = send_request2()
        if ret == 0:
            break
        count += 1


if __name__ == "__main__":
    main()
